
// VIC2CalcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VIC2Calc.h"
#include "VIC2CalcDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CVIC2CalcDlg dialog



CVIC2CalcDlg::CVIC2CalcDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_VIC2CALC_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVIC2CalcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_CHAR, m_CharAddr);
	DDX_Control(pDX, IDC_EDIT_SCREEN, m_ScrAddr);
	DDX_Control(pDX, IDC_CHECK_EIC, m_IEC);
	DDX_Control(pDX, IDC_EDIT_ANSWER, m_Answer);
}

BEGIN_MESSAGE_MAP(CVIC2CalcDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CVIC2CalcDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CVIC2CalcDlg message handlers

BOOL CVIC2CalcDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVIC2CalcDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVIC2CalcDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CVIC2CalcDlg::OnBnClickedButton1()
{
	CString sCharAddr;
	m_CharAddr.GetWindowText(sCharAddr);
	int nCharAddr = _tcstol(sCharAddr, NULL, 16);

	CString sScrAddr;
	m_ScrAddr.GetWindowText(sScrAddr);
	int nScrAddr = _tcstol(sScrAddr, NULL, 16);

	if (nCharAddr > 0xffff)
	{
		m_Answer.SetWindowText(_T("Character address out of range"));
		return;
	}

	if (nScrAddr > 0xffff)
	{
		m_Answer.SetWindowText(_T("Screen address out of range"));
		return;
	}

	if (nCharAddr % 0x800 != 0)
	{
		m_Answer.SetWindowText(_T("Character address must be aligned of $800 ($2000 in bitmap mode)"));
		return;
	}

	if (nScrAddr % 0x400 != 0)
	{
		m_Answer.SetWindowText(_T("Screen address must be aligned of $400"));
		return;
	}

	if ((nCharAddr & ~0x3fff) != (nScrAddr & ~0x3fff))
	{
		m_Answer.SetWindowText(_T("Character and Screen addresses must be in the same bank"));
		return;
	}

	if ((nCharAddr >= 0x1000 && nCharAddr < 0x2000) || (nCharAddr >= 0x9000 && nCharAddr < 0xa000))
	{
		m_Answer.SetWindowText(_T("Character address is in the character ROM bank"));
		return;
	}

	if ((nScrAddr >= 0x1000 && nScrAddr < 0x2000) || (nScrAddr >= 0x9000 && nScrAddr < 0xa000))
	{
		m_Answer.SetWindowText(_T("Screen address is in the character ROM bank"));
		return;
	}

	int ad018 = (((nScrAddr & 0x3fff) / 0x0400) << 4) | (((nCharAddr & 0x3fff) / 0x0800) << 1);
	int ad000 = 3 - (nCharAddr >> 14); //nScrAddr works as well since we know they are in the same bank now

	CString sd000;
	if (m_IEC.GetCheck())
	{
		sd000.Format(_T("LDA $DD00\r\nAND #$FC\r\nORA #$%02X\r\nSTA $DD00\r\n"), ad000);
	}
	else
	{
		sd000.Format(_T("LDA #$%02X\r\nSTA $DD00\r\n"), ad000);
	}

	CString sd018;
	sd018.Format(_T("LDA #$%02X\r\nSTA $D018\r\n"), ad018);

	m_Answer.SetWindowText(sd000 + sd018);
}
